#!/usr/bin/perl -w

#  : 
# 
# update-sql\
# 	XXI-4.2.sql
# 	XXI-4.3.sql
# 	XXI-5.0.sql
# 	CMS-4.2.sql
# 	CMS-4.3.sql
# 	CMS-5.0.sql
#
#        
# 		 4.1   4.2, 4.3, 5.0
# 		 4.2   4.3, 5.0
# 		 5.0  

use strict;
use CGI::Carp;

require "common.pl";

my %c;

my $sp_conf = $ARGV[0] || '/var/www/cgi-bin/sp/sp.conf';

#    
open CONFIG, $sp_conf or die("Can't open $sp_conf: $!\n");
	while (<CONFIG>)
	{
		chomp;
		s/#.*//;
		s/^\s+//;
		s/\s+$//;
		next unless length;
		my ($var, $value) = split( /\s*=\s*/, $_, 2 );
		$c{$var} = $value;
	}
close CONFIG;

chdir "/var/www/cgi-bin/sp/update-sql/";

#     XXI  CMS
my @xxi_files = <XXI-*.sql>;
my @cms_files = <CMS-*.sql>;

#      XXI  
# , , '4.1', '5.3'  '7.12'
# 4.1  (      RPM ALT)
my $db_structure_version =
	sqlff(q[select RDB$DESCRIPTION from RDB$RELATIONS where RDB$RELATION_NAME = 'SP_SETTINGS'])
	|| 0;

#   ,     
print "Database structure version is: $db_structure_version\n";

my $changes_made = 0;

# --------------------------------------------------------------------------
# XXI
# --------------------------------------------------------------------------
for ( sort @xxi_files )
{
	#       XXI
	if ( /^XXI-(.+)\.sql$/ )
	{
		if ( $db_structure_version < $1 )
		{
			print "Applying update to XXI DB structure version $1...\n";

			system
			(
				"perl",
				"/var/www/cgi-bin/sp/update_xxi.pl",
				"/var/www/cgi-bin/sp/sp.conf",
				"/var/www/cgi-bin/sp/update-sql/$_" # filename
			);

			$changes_made = 1;
		}
	}
}

# --------------------------------------------------------------------------
# CMS
# --------------------------------------------------------------------------

my $isql = find_tool('isql');

for ( sort @cms_files )
{
	#       CMS
	if ( /^CMS-(.+)\.sql$/ )
	{
		if ( $db_structure_version < $1 )
		{
			print "Applying update to CMS DB structure version $1...\n";

			system
			(
				$isql,
				'-charset',
				'WIN1251',
				'-input',
				"/var/www/cgi-bin/sp/update-sql/$_" # filename
			);

			$changes_made = 1;
		}
	}
}

if ( $changes_made )
{
	print "Database structure updated.\n";
}
else
{
	print "Database structure already newest or no DB updates in this release.\n";
}
